local S_H_B_Info_Text = "|cffffffffHiding/Showing a buff is not instant, but close, once the buff / debuff frame updates itself then you'll see the proper result.  Buff / Debuff frame updates when it receives new information to go into the frame.  i.e every few seconds when actively fighting.";

function SemiHideBuffs_OnEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 = ...;
	if (event=="ADDON_LOADED") and (string.lower(arg1) == "semi_hide_buffs") then
		SlashCmdList["SEMI_HIDE_BUFFSCOMMAND"] = SemiHideBuffs_SlashHandler;
		SLASH_SEMI_HIDE_BUFFSCOMMAND1 = "/shb";
		SLASH_SEMI_HIDE_BUFFSCOMMAND2 = "/shbs";
		if SemiHiddenBuffs == nil then
			SemiHiddenBuffs = {};
		end
		if SemiStickyBuffs == nil then
			SemiStickyBuffs = true;
		end
		if SemiHideAll == nil then
			SemiHideAll = false;
		end
	end
end

function Semi_Hide_Buffs_ToggleSticky()
	if SemiStickyBuffs then
		SemiStickyBuffs = false;
		print("Sticky Buffs Off - Buffs will Collapse");
	else
		SemiStickyBuffs = true;
		print("Sticky Buffs On - Buffs will stay put");
	end
	Semi_Hide_Buffs_Config_FrameCheckButtonSticky:SetChecked(SemiStickyBuffs);
end

function Semi_Hide_Buffs_ToggleBuffs()
	if SemiHideAll then
		SemiHideAll = false;
		TemporaryEnchantFrame:Show();
		if ((GetNumSubgroupMembers() > 0) or (IsInRaid())) and (not ConsolidatedBuffs:IsShown()) then
			print("If you use the Consolidated Buffs Feature, You must reset it back in the Options Menu - Buffs and Debuffs Sub Menu");
		end
		print("Now only hiding Buffs and Debuffs you manually specify.  Showing all others.");
	else
		SemiHideAll = true;
		print("Now hiding all Buffs and Debuffs!");
	end
	Semi_Hide_Buffs_Config_FrameCheckButtonBuffs:SetChecked(SemiHideAll);
end

function Semi_Hide_Buffs_PrintHideList()
	SemiListCount = 0;
	for k,v in pairs(SemiHiddenBuffs) do
		SemiListCount = SemiListCount + 1
	end
	if SemiListCount > 0 then
		SemiListIndex = 1;
		print("Buffs to Be Hidden: "..SemiListCount);
		for k,v in pairs(SemiHiddenBuffs) do
		print("["..SemiListIndex.."]"..k);
		SemiListIndex = SemiListIndex + 1
		end
	end
	if SemiListCount == 0 then
		print("No Buffs are being Hidden");
	end
end

function SemiHideBuffs_SlashHandler(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	command = string.lower(command);
	if command == "h" and rest ~= "" then
		if SemiHiddenBuffs[rest] == 1 then
			print(rest, "is already in the list.");
		else
			SemiHiddenBuffs[rest] = 1;
			print(rest, "has been added to hide list.");
		end
	elseif command == "s" and rest ~= "" then
		if SemiHiddenBuffs[rest] == 1 then 
			SemiHiddenBuffs[rest] = nil;
			print(rest, "has been removed from list.");
		else
			print(rest, "is not in the hide list.");
		end
	elseif command == "?" and rest ~= "" then
		if SemiHiddenBuffs[rest] ~= nil then
			print(rest, " is in the list to hide.");
		elseif SemiHiddenBuffs[rest] == nil then
			print(rest, " is not in the list.");
		end
	elseif (command == "option") or (command == "options") then
		InterfaceOptionsFrame_OpenToCategory("Semi Hide Buffs");
	elseif command == "sticky" then
		Semi_Hide_Buffs_ToggleSticky();
	elseif command == "all" then
		Semi_Hide_Buffs_ToggleBuffs();
	elseif (command == "p") or (command == "list")  then
		Semi_Hide_Buffs_PrintHideList();
	else
		print("|cffF58CBA Semi Hide Buffs UI Commands:");
		print("/shb option(s) - |cffF58CBAOpens option menu");
		print("/shb h NameOfBuffHere  - |cffF58CBATo hide a buff and add it to the list. ");
		print("/shb s NameOfBuffHere - |cffF58CBATo show a buff and remove it from the list. ");
		print("/shb ? NameOfBuffHere - |cffF58CBATo find out if the Buff is in the list. ");
		--print("   p or list- |cffF58CBATo print the list of hidden buffs. ");
		--print("   sticky - |cffF58CBAToggles sticky buffs on or off. ");		
		--print("   all - |cffF58CBAToggles all Buffs and Debuffs, the Consolidated Buffs Box(if you use it) and the Temporary Enchant Frame(s).");
	end
end

function Semi_Hide_Buffs_Config_OnLoad(self)
	panel = Semi_Hide_Buffs_Config_Frame;
	panel.name = "Semi Hide Buffs";
	if IsAddOnLoaded("Semi_Core") then
		panel.parent = "Semi";
	end
	Semi_Hide_Buffs_Config_FrameTitle:SetText("Semi Hide Buffs");
	Semi_Hide_Buffs_Config_FrameInfo:SetText(S_H_B_Info_Text);
	InterfaceOptions_AddCategory(panel);
end

function Semi_Hide_Buffs_Config_OnShow(self)
	_G[self:GetName().."CheckButtonSticky"]:SetChecked(SemiStickyBuffs);
	_G[self:GetName().."CheckButtonBuffs"]:SetChecked(SemiHideAll);
end

function Semi_Hide_Buffs_Config_Option_OnClick(self)
	if (self:GetName() == (self:GetParent():GetName().."CheckButtonSticky" ) ) then
		Semi_Hide_Buffs_ToggleSticky();
	elseif (self:GetName() == (self:GetParent():GetName().."CheckButtonBuffs" ) ) then
		Semi_Hide_Buffs_ToggleBuffs();
	end
end

local frame = CreateFrame("Frame", "Semi_Hide_Buffs_MyAddOnFrame");
frame:SetScript("OnEvent", SemiHideBuffs_OnEvent);
frame:RegisterEvent("ADDON_LOADED");

local buffsPerRow = 20;
local buffWidth = TempEnchant1:GetWidth();
local buffHeight = TempEnchant1:GetHeight();
local buffXInterval = buffWidth + 6;  

-- Create 3 empty rows for the buffs
local Buffs = {};
for rowNum = 1, 3 do  
  local rowData = {};
  for colNum = 1, buffsPerRow do
    rowData[colNum] = {["valid"] = false};
  end
  Buffs[rowNum] = rowData;
end

local function Semi_BuffFrame_UpdateAllBuffAnchors_Hook()
  local buff;
  local unit = PlayerFrame.unit;
  local name, rank, texture, count, debuffType, duration, expirationTime, source;
  local row, rowNum, colNum, element;

if (SemiHideAll) then
	for i=1, BUFF_ACTUAL_DISPLAY do
		buff = _G["BuffButton"..i];
		buff:ClearAllPoints();
		buff:Hide();
	end
	if ConsolidatedBuffs:IsShown() then
		ConsolidatedBuffs:Hide();
	end
	TemporaryEnchantFrame:Hide();
	return;
end
  

if (SemiStickyBuffs) then
  -- before starting the first index, purge any unmatched buffs and clear out match indications
	for rowNum, row in ipairs(Buffs) do
		for colNum, buff in ipairs(row) do
			if (not buff.matched) then
				buff.valid = false;
			end
			buff.matched = false;
		end
	end

	for i = 1, BUFF_ACTUAL_DISPLAY do
		buff = _G["BuffButton" .. i];
	
		if (not buff.consolidated) then  
			name, rank, texture, count, debuffType, duration, expirationTime, source = UnitAura(unit, i, "HELPFUL");  -- todo, could do some interesting filtering based upon shouldConsolidate
	  -- if the buff is suppose to be hidden, put it on row 3 which will be the hidden row for the buff
			if (SemiHiddenBuffs[name] == 1) then
				rowNum = 3;
      -- pick a row based upon duration/source
			elseif (duration == 0) then
        -- no duration
				rowNum = 1;
			elseif (duration >= 600) then
        -- duration >= 10 minutes
				rowNum = 1;
			else
        -- duration < 10 minutes but greater zero(no duration)
				rowNum = 2;
			end
		
		row = Buffs[rowNum];
		colNum = nil;

      -- find an exact match (name, rank, texture, duration, source) 
		for c, v in ipairs(row) do
			if ((v.valid == true) and (v.matched == false) and (name == v.name) and (rank == v.rank) and (texture == v.texture) and (duration == v.duration) and (source == v.source)) then
				colNum = c;
				break;
			end
		end
	
      -- find a loose match (name, texture) 
		if (colNum == nil) then
			for c, v in ipairs(row) do
				if ((v.valid == true) and (v.matched == false) and (name == v.name) and (texture == v.texture)) then
					colNum = c;
					break;
				end
			end
		end
	 
      -- find the first hole
		if (colNum == nil) then
			for c, v in ipairs(row) do
				if (v.valid == false) then
					colNum = c;
				break;
				end
			end
		end

      -- if all else fails, make a new spot at the end of the row
		if (colNum == nil) then
			colNum = #row + 1;
			if (colNum > buffsPerRow) then
          -- There's no room for this buff, so just hide it
				buff:Hide();
				return;
			end
		end

		element = row[colNum];
		element["valid"] = true;
		element["matched"] = true;
		element["name"] = name;
		element["rank"] = rank;
		element["texture"] = texture;
		element["duration"] = duration;    
		element["source"] = source;

		if ConsolidatedBuffs:IsShown() and (not TempEnchant1:IsShown()) then
			buff:ClearAllPoints();
			buff:SetPoint("TOPRIGHT", ConsolidatedBuffs, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
		elseif (TempEnchant1:IsShown() and (not TempEnchant2:IsShown())) then
			buff:ClearAllPoints();
			buff:SetPoint("TOPRIGHT", TempEnchant1, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
		elseif TempEnchant2:IsShown() then
			buff:ClearAllPoints();
			buff:SetPoint("TOPRIGHT", TempEnchant2, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
		else
			buff:ClearAllPoints();
			buff:SetPoint("TOPRIGHT", BuffFrame, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2)); 
		end
		if SemiHiddenBuffs[name] == 1 then
			buff:Hide();
		end
		end
	end
	
else 
	for i = 1, BUFF_ACTUAL_DISPLAY do
			buff = _G["BuffButton" .. i];
	
		if (not buff.consolidated) then
			name, rank, texture, count, debuffType, duration, expirationTime, source = UnitAura(unit, i, "HELPFUL");
			--print("Duration for "..name.." is "..duration);
			if duration == nil then duration = 1; end
			if (SemiHiddenBuffs[name] == 1) then
				rowNum = 3;
			end
			if (duration == 0) or (duration >= 600) then
				rowNum = 1;
			else
				rowNum = 2;
			end
			
			ColNumForRow1 = 0;
			ColNumForRow2 = 0;
			for j=1, i do
				--changed the following to a local
				local Nname, Nrank, Ntexture, Ncount, NdebuffType, Nduration, NexpirationTime, Nsource;
				Nname, Nrank, Ntexture, Ncount, NdebuffType, Nduration, NexpirationTime, Nsource = UnitAura("player", j, "HELPFUL");
				if Nduration == nil then Nduration = 1; end
				if rowNum == 1 then
					if _G["BuffButton"..j]:IsShown() and ((Nduration >= 600) or (Nduration == 0)) then
						ColNumForRow1 = ColNumForRow1 + 1;
					end
				elseif rowNum == 2 then
					--if _G["BuffButton"..j]:IsShown() and (Nduration == "nil" or Nduration == "" or Nduration == nil) then
						--ColNumForRow2 = ColNumForRow2 + 1;
					if _G["BuffButton"..j]:IsShown() and ((Nduration < 599) and (Nduration ~= 0)) then
						ColNumForRow2 = ColNumForRow2 + 1;
					end
				end
			end
			if rowNum == 1 then
				colNum = ColNumForRow1 % buffsPerRow;
			elseif rowNum == 2 then
				colNum = ColNumForRow2 % buffsPerRow;
			end
			
			if ConsolidatedBuffs:IsShown() and (not TempEnchant1:IsShown()) then
				buff:ClearAllPoints();
				buff:SetPoint("TOPRIGHT", ConsolidatedBuffs, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
			elseif (TempEnchant1:IsShown() and (not TempEnchant2:IsShown())) then
				buff:ClearAllPoints();
				buff:SetPoint("TOPRIGHT", TempEnchant1, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
			elseif TempEnchant2:IsShown() then
				buff:ClearAllPoints();
				buff:SetPoint("TOPRIGHT", TempEnchant2, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
			else
				buff:ClearAllPoints();
				buff:SetPoint("TOPRIGHT", BuffFrame, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2)); 
			end
			if SemiHiddenBuffs[name] == 1 then
				buff:Hide();
			end
		end
	end
end
end
hooksecurefunc("BuffFrame_UpdateAllBuffAnchors", Semi_BuffFrame_UpdateAllBuffAnchors_Hook);

function Semi_DebuffButton_UpdateAnchors_Hook(buttonName, index)
  local buffName = buttonName..index;
  local buff = _G[buffName];
  local name, rank, texture, count, debuffType, duration, expirationTime, source = UnitAura("player", index, "HARMFUL");
  
  if (SemiHideAll) then
	  buff:ClearAllPoints();
	  buff:Hide();
	  return;
  end
  
  if (SemiHiddenBuffs[name] == 1) then
	buff:ClearAllPoints();
	buff:Hide();
	return;
  end
  NewcolNum = 0;
  for i=1, index do
	if _G["DebuffButton"..i]:IsShown() then
		NewcolNum = NewcolNum + 1;
	end
  end
  local rowNum = 3 + ceil(index / buffsPerRow);
  local colNum = NewcolNum % buffsPerRow; 

	if ConsolidatedBuffs:IsShown() then
		buff:ClearAllPoints();
		buff:SetPoint("TOPRIGHT", ConsolidatedBuffs, "TOPRIGHT", (-(colNum - 1) * buffXInterval) -40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
	else
		buff:ClearAllPoints();
		buff:SetPoint("TOPRIGHT", BuffFrame, "TOPRIGHT", (-(colNum - 1) * buffXInterval) - 40, -(rowNum - 1) * (buffHeight + BUFF_ROW_SPACING - 2));
	end  
end
hooksecurefunc("DebuffButton_UpdateAnchors", Semi_DebuffButton_UpdateAnchors_Hook);
